<?php 
class Color extends AppObjeto{
	protected static $_aliasTabla = 'a';
	protected static $_nombreTabla = 'COLORFL';
	protected static $_campoPK = 'CODIGO';
	
	protected $codigo;
	public function getCodigo() {
	    return $this->codigo;
	}
	public function setCodigo($codigo) {
	    $this->codigo = $codigo;
	}
	protected $nombre;
	public function getNombre() {
	    return $this->nombre;
	}
	public function setNombre($nombre) {
	    $this->nombre = $nombre;
	}
	
	
	
	
	
	protected static function initMetaDatos(){
		self::addPropiedadBD('a', 'CODIGO', 'codigo', self::META_VARCHAR);
		self::addPropiedadBD('a', 'NOMBRE', 'nombre', self::META_VARCHAR);
	}
	
	
	public static function listado_select(){
		$select = self::selectObjeto();
		
		$resultado = self::selectExecute($select);
	
		$datos = $resultado->getDatos();
		$salida = array();
	
		$salida[]='';
		foreach ($datos as $elemento){
			$salida[$elemento['codigo']] =$elemento['nombre'];
		}
		return $salida;
	
	}
	
	
		/*
		 * Devuelve los clientes para autocompletar 
		 * @param array $params: busqueda
		 * @return AppListado
		 * 
		 */
		public static function autocompletar($params){
			$select = self::selectObjeto();
			$select->columns(array('label'=>'NOMBRE','value'=>'NOMBRE'));
			// buscar por nombre en cualquier orden
			if (isset($params['busqueda']) && $params['busqueda']) {
				$palabras = explode(' ', $params['busqueda']);
				$sql = array();
				foreach ($palabras as $palabra){
					if ($palabra){
						$sql[] = 'NOMBRE like \'%'.$palabra.'%\'';
					}
				}
				$sql = implode(' and ', $sql);
				$select->where($sql);
			}
			
			$resultado = self::selectExecute($select);
			return $resultado;
	 	} 
	
	
}